iwm - Remove unused TX_CMD_NEXT_FRAME_*
[dragonfly.git] / initrd / mkinitrd.sh
blob14d10910bb6b80388995f7db6b0ef6b6b323551f
1 #!/bin/sh
3 # Copyright (c) 2010, 2018
4 # The DragonFly Project. All rights reserved.
6 # Redistribution and use in source and binary forms, with or without
7 # modification, are permitted provided that the following conditions
8 # are met:
10 # 1. Redistributions of source code must retain the above copyright
11 # notice, this list of conditions and the following disclaimer.
12 # 2. Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in
14 # the documentation and/or other materials provided with the
15 # distribution.
16 # 3. Neither the name of The DragonFly Project nor the names of its
17 # contributors may be used to endorse or promote products derived
18 # from this software without specific, prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
21 # ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
22 # LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
23 # FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
24 # COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
25 # INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
26 # BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
27 # LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
28 # AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
35 # Description
37 # This tool packs the (statically linked) rescue tools (at /rescue by
38 # default) and contents specified by "-c <content_dirs>", such as the
39 # necessary etc files, into an UFS-formatted VN image. This image is
40 # installed at /boot/kernel/initrd.img.gz and used as the initial ramdisk
41 # to help mount the real root filesystem when it is encrypted or on LVM.
46 # Default configurations
49 # Directory hierarchy on the initrad
51 # * 'new_root' will always be created
52 # * 'sbin' will be symlinked to 'bin'
53 # * 'tmp' will be symlinked to 'var/tmp'
55 INITRD_DIRS="bin dev etc mnt var"
57 # Directory of the statically linked rescue tools which will be copied
58 # onto the initrd.
59 RESCUE_DIR="/rescue"
61 # Specify the location that the initrd will be installed to, i.e.,
62 # <BOOT_DIR>/kernel/initrd.img.gz
63 BOOT_DIR="/boot"
65 # Maximum size (number of MB) allowed for the initrd image
66 INITRD_SIZE_MAX="15" # MB
70 # Helper functions
73 log() {
74 echo "$@" >&2
77 error() {
78 local rc=$1
79 shift
80 log "$@"
81 exit ${rc}
84 check_dirs() {
85 for _dir; do
86 [ -d "${_dir}" ] ||
87 error 1 "Directory '${_dir}' does not exist"
88 done
89 return 0
92 # Calculate the total size of the given directory, taking care of the
93 # hard links.
95 # NOTE: Do not use 'du' since it gives the disk usage of the files,
96 # which varies between different filesystems.
98 calc_size() {
99 find "$1" -ls | \
100 awk '{ print $7,$1 }' | \
101 sort -n -k 2 | \
102 uniq -f 1 | \
103 awk '{ sum+=$1 } END { print sum }' # byte
108 # Functions
111 calc_initrd_size() {
112 log "Calculating required initrd size ..."
113 isize=0
114 for _dir; do
115 csize=$(calc_size ${_dir})
116 log "* ${_dir}: ${csize} bytes"
117 isize=$((${isize} + ${csize}))
118 done
119 # Round initrd size up by MB
120 isize_mb=$(echo ${isize} | awk '
121 function ceil(x) {
122 y = int(x);
123 return (x>y ? y+1 : y);
126 mb = $1/1024/1024;
127 print ceil(mb);
129 # Add additional 1 MB
130 echo $((${isize_mb} + 1))
133 create_vn() {
134 kldload -n vn
135 VN_DEV=$(vnconfig -c -S ${INITRD_SIZE}m -Z -T vn ${INITRD_FILE}) &&
136 echo "Configured ${VN_DEV}" ||
137 error 1 "Failed to configure VN device"
139 newfs -i 131072 -m 0 /dev/${VN_DEV}s0 &&
140 echo "Formatted initrd image with UFS" ||
141 error 1 "Failed to format the initrd image"
142 mount_ufs /dev/${VN_DEV}s0 ${BUILD_DIR} &&
143 echo "Mounted initrd image on ${BUILD_DIR}" ||
144 error 1 "Failed to mount initrd image on ${BUILD_DIR}"
147 destroy_vn() {
148 umount /dev/${VN_DEV}s0 &&
149 echo "Unmounted initrd image" ||
150 error 1 "Failed to umount initrd image"
151 vnconfig -u ${VN_DEV} &&
152 echo "Unconfigured ${VN_DEV}" ||
153 error 1 "Failed to unconfigure ${VN_DEV}"
156 make_hier() {
157 mkdir -p ${BUILD_DIR}/new_root ||
158 error 1 "Failed to mkdir ${BUILD_DIR}/new_root"
159 # Symlink 'sbin' to 'bin'
160 ln -sf bin ${BUILD_DIR}/sbin
161 # Symlink 'tmp' to 'var/tmp', as '/var' will be mounted with
162 # tmpfs, saving a second tmpfs been mounted on '/tmp'.
163 ln -sf var/tmp ${BUILD_DIR}/tmp
164 for _dir in ${INITRD_DIRS}; do
165 [ ! -d "${BUILD_DIR}/${_dir}" ] &&
166 mkdir -p ${BUILD_DIR}/${_dir}
167 done
168 echo "Created directory structure"
171 copy_rescue() {
172 cpdup -o -u ${RESCUE_DIR}/ ${BUILD_DIR}/bin/ &&
173 echo "Copied ${RESCUE_DIR} to ${BUILD_DIR}/bin" ||
174 error 1 "Failed to copy ${RESCUE_DIR} to ${BUILD_DIR}/bin"
177 copy_content() {
178 for _dir in ${CONTENT_DIRS}; do
179 cpdup -o -u ${_dir}/ ${BUILD_DIR}/ &&
180 echo "Copied ${_dir} to ${BUILD_DIR}" ||
181 error 1 "Failed to copy ${dir} to ${BUILD_DIR}"
182 done
185 print_info() {
186 lt ${BUILD_DIR}
187 df -h ${BUILD_DIR}
190 # Check the validity of the created initrd image before moving over.
191 # This prevents creating an empty and broken initrd image by running
192 # this tool but without ${CONTENT_DIRS} prepared.
194 # NOTE: Need more improvements.
196 check_initrd()
198 [ -x "${BUILD_DIR}/sbin/oinit" ] &&
199 [ -x "${BUILD_DIR}/bin/sh" ] &&
200 [ -x "${BUILD_DIR}/etc/rc" ] || {
201 destroy_vn
202 error 1 "Ivalid initrd image!"
206 usage() {
207 error 2 \
208 "usage: ${0##*/} [-b boot_dir] [-r rescue_dir]" \
209 "[-s size] [-S max_size] -c <content_dirs>"
214 # Main
217 while getopts :b:c:hr:s:S: opt; do
218 case ${opt} in
220 BOOT_DIR="${OPTARG}"
223 CONTENT_DIRS="${OPTARG}"
226 usage
229 RESCUE_DIR="${OPTARG}"
232 INITRD_SIZE="${OPTARG}"
235 INITRD_SIZE_MAX="${OPTARG}"
238 log "Invalid option -${OPTARG}"
239 usage
242 log "Option -${OPTARG} requires an argument"
243 usage
245 esac
246 done
248 shift $((OPTIND - 1))
249 [ $# -ne 0 ] && usage
250 [ -z "${BOOT_DIR}" -o -z "${RESCUE_DIR}" -o -z "${CONTENT_DIRS}" ] && usage
251 check_dirs ${BOOT_DIR} ${RESCUE_DIR} ${CONTENT_DIRS}
253 VN_DEV=""
254 INITRD_SIZE=${INITRD_SIZE%[mM]} # MB
255 INITRD_SIZE_MAX=${INITRD_SIZE_MAX%[mM]} # MB
257 BUILD_DIR=$(mktemp -d -t initrd) || error $? "Cannot create build directory"
258 echo "Initrd build directory: ${BUILD_DIR}"
259 INITRD_FILE="${BUILD_DIR}.img"
260 INITRD_DEST="${BOOT_DIR}/kernel/initrd.img.gz"
262 CSIZE=$(calc_initrd_size ${RESCUE_DIR} ${CONTENT_DIRS})
263 echo "Required initrd image size: ${CSIZE} MB"
264 if [ -n "${INITRD_SIZE}" -a "${INITRD_SIZE}" != "0" ]; then
265 if [ ${CSIZE} -gt ${INITRD_SIZE} ]; then
266 error 1 "Given initrd size (${INITRD_SIZE} MB) too small"
268 else
269 INITRD_SIZE=${CSIZE}
271 echo "Initrd size: ${INITRD_SIZE} MB"
273 if [ -n "${INITRD_SIZE_MAX}" -a "${INITRD_SIZE_MAX}" != "0" ] && \
274 [ ${INITRD_SIZE} -gt ${INITRD_SIZE_MAX} ]; then
275 error 1 "Exceeded the maximum size (${INITRD_SIZE_MAX} MB)"
278 create_vn
279 make_hier
280 copy_rescue
281 copy_content
282 print_info
283 destroy_vn
284 rm -rf ${BUILD_DIR}
286 echo -n "Compressing ${INITRD_FILE} ..."
287 gzip -9 ${INITRD_FILE}
288 echo " OK"
290 if [ -f "${INITRD_DEST}" ]; then
291 echo -n "Backing up ${INITRD_DEST} ..."
292 mv ${INITRD_DEST} ${INITRD_DEST}.old
293 echo " OK (${INITRD_DEST}.old)"
296 echo -n "Copying ${INITRD_FILE}.gz to ${INITRD_DEST} ..."
297 install -o root -g wheel -m 444 ${INITRD_FILE}.gz ${INITRD_DEST}
298 echo " OK"
299 rm -f ${INITRD_FILE}.gz